#pragma once
#include<vector>
#include<GL/gl.h>
#include<GL/glu.h>
#include<math.h>

#include<vcg/Point2.h>
#include<vcg/Point3.h>

using namespace std;
using namespace vcg;

class CIVertex
{
public :
	CIVertex() {}
	CIVertex(Point3f &pp, Point3f &nn) {p=pp; n=nn;}
	CIVertex(Point3f &pp, Point3f &nn,float ss, float tt) {p=pp; n=nn; t=Point2f(ss,tt);}
	Point3f p;
	Point3f n;
	Point2f t;
};

class CIFace
{
public:
	CIVertex *v[3];
	Point2f t[3];
	Point3f n;
};

class CIMesh {
public:
	vector< CIVertex > vert;
	vector< CIFace > face;
	void ComputeFaceNormal();
	void ComputeVertNormal();

	template <bool NormFlag, bool TexFlag> Draw()
	{
		glBegin(GL_TRIANGLES);
		vector<CIFace>::const_iterator fi;
		for(fi=face.begin();fi!=face.end();++fi)
		{
			if(NormFlag) glNormal((*fi).v[0]->n);
			if(TexFlag) glTexCoord((*fi).v[0]->t);
			glVertex((*fi).v[0]->p);
			if(NormFlag) glNormal((*fi).v[1]->n);
			if(TexFlag) glTexCoord((*fi).v[0]->t);
			glVertex((*fi).v[1]->p);
			if(NormFlag) glNormal((*fi).v[2]->n);
			if(TexFlag) glTexCoord((*fi).v[0]->t);
			glVertex((*fi).v[2]->p);
		}
		glEnd();
	}
	
	void DrawPoints();
	bool Empty() const {return vert.empty() &&  face.empty();}
	void Clear();
};

class CIShape
{
public:
	static void Sphere(CIMesh &m, const float radius, const int pl, const int md);
};
